
/*1. WOLTOMIERZ od  0V do 25.0V. PRĄD MIERZONY OD 0 do 2000 mA plus bezpiecznik elektroniczny 
 z nastawą prądu wyłączenia. Panel ma dwie opcje działania, z bezpiecznikiem i bez bezpiecznika.
Schemat RYS.2 Arduino Pro Mini +5V; 16MHz, Płytka Modifikowana  /dodatkowe wejście AREF/
Schemat RYS.3 Wersja z mikroprocesorem ATmega 16  +5V; 8MHz  
Napięcie do pomiaru podane na pin A0: lp - pomiarów, oblicza średnią i wyświetla na LCD.
Dzielnik napięcia, od góry R1 = 68K, od masy R2 = 18K.
Szeregowo z diodą Zenera 5V1 rezystor R3 = 470. Dzielnik dzieli napięcie w stosunku 1 : 4,84

Interfejs 4-bitowy dla wyświetlacza LCD 2x16: piny Arduino(n):[(n)z /piny LCD/]: 
[(2)z/4,RS/]-[(8)z/6,E/]-[(4)z/11,DB4/]-[(5)z/12,DB5/]-[(6)z/13,DB6/]-[(7)z/14,DB7/]
[GND z/1,Vss/]-[+5V z/2,Vdd/]-[Vo z/3/]-[GND z/5,R/W/]-[+5V z/15,LEDA/]-[GND z/16,LEDK/]

*/
#define kas 3                         // przycisk kas, dołączony do pin 3, zewnętrzne przerwanie INT1
#include <LiquidCrystal.h>            //Dołączenie bilbioteki,obsługa LCD
LiquidCrystal lcd(2,8,4,5,6,7);       //interfejs 4-bitowy dla LCD 
                                     // do pinów Arduino(2,8,4,5,6,7)
                                     
float volt = 0;                 //zmienna, pojedynczy pom. napięcia, jeden ze lp pomiarów
float I = 0 ;                   //zmienna, pojedynczy pom. prądu, jeden ze lp pomiarów
int adc;                        //zmienna przechowuje daną cyfrową z pomiaru napięcia z A0
int adc1;                       //przechowuje iloczyn adc*5
int adcp;                       //zmienna przechowuje daną cyfrową z pomiaru prądu z A1
int adcp1;                      //zmienna przechowuje daną cyfrową z pomiaru prądu po wzmocnieniu
int adcop;                      //zmienna przechowuje daną cyfrową z nastawy ograniczenia prądu z A2
byte be = 0xFF;                 //zmienna bajt,pojedyncze bity bit0 i bit1 jako znaczniki ustawiane/zerowane
byte i = 0 ;
byte lp = 25;                   // liczba pomiarów napięcia/prądu
float sumaV = 0;                // przechowuje sumę lp pom. napięcia
float sumaI = 0;                // przechowuje sumę lp pom. prądu
float volts;                    // przechowuje napięcie średnie obliczone ze lp pomiarów
float Is;                       // przechowuje prąd średni obliczony ze lp pomiarów

void setup()
{
  pinMode(kas, INPUT_PULLUP);        // pin 3 podciągnięty do +5V, dołączony przycisk kas
  pinMode(9, OUTPUT);               // zewnętrzene sterowanie,normalnie stan niski
  pinMode(10, OUTPUT);              // zewnętrzen sterowanie, normalnie stan wysoki
  digitalWrite(9, LOW);             // sterowanie +LED czerwona
  digitalWrite(10, HIGH);           // sterowanie -LED czerwona
  pinMode(11, OUTPUT);              // sterowanie żółtej diody LED
  digitalWrite(11, LOW);
  pinMode(12, OUTPUT);              //pin12....PB4 sterowanie tranzystora w układzie pomiaru napięcia
  digitalWrite(12,HIGH);            //tranzystor blokuje wzmocnienie  na zakresie ( 1... 25) V
  pinMode( 13, OUTPUT);             //pin 13 sterownie tranzystora w układzie pomiaru prądu
  lcd.begin(16, 2);                 //Deklaracja typu LCD
  lcd.clear(); 
  lcd.setCursor(5, 0);              //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print("PANEL");               //Wyświetlenie nazwy urządzenia
  lcd.setCursor(3, 1);              //wiersz drugi 3-cia kolumna
  lcd.print("POMIAROWY"); 
  analogReference(EXTERNAL);         //  Napięcie Referencjne podane na AREF
  delay(1500);                      // czas wyświetalania nazwy urządzenia /ms/
  }
                                    // Uref = 5.0V / 1023 = 4.8875 mV/bit 
                                        
//---------------------------------------POMIAR NAPIĘCIA-------------------------------------------   
                                 //zakres /0 ... 1000 mV/ cztery podzakresy
                                     
void loop()                            // początek pętli głównej programu "loop"
{
  odczytA0();                       // odczyt z pinu A0,które jest przeznaczone do pomiaru napięcia mierzonego
 if (adc <= 154)                    //zakres /0 ... 1000 mV/(adc <= 154)odblokowany wzmacniacz pomiarowy
                                    // pomiar małych napięć wzmacniaczem różnicowym
 {                        
   digitalWrite(12,LOW);             // odblokowanie zakresu (0...1000) mV tranzystor Q1 wyłączony
   for (int i=0; i<lp; i++)        
 {                        
   adc1 = analogRead(A0);
   adc1 = adc1 * 5 ;                // *5 aby zwiększyć rozdzielczość pomiaru
//................................................/1/............................................................   
   if ((adc1 >= 2135) && (adc1 <= 3130 ))              // podzakres od 0 mV do 333 mV >= 2130 <= 3070
 {                              
   volt = map ( adc1, 2155, 3115, 338, 6 );               
   sumaV = sumaV + volt;                                  // sumuje kolejne pomiary aż do lp
   delay(10);                                       // czas między każdym jednym ze lp  pomiarów napięcia  
 } 
//................................................/2/............................................................ 
  if ((adc1 >= 1200) && (adc1 < 2135))                  // podzakres od 333 mV do 666 mV
 {
   volt = map ( adc1, 1215, 2135, 671, 343);
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                                         // czas między każdym jednym ze lp  pomiarów napięcia
 }
//................................................/3/...........................................................
  if ((adc1 >= 550) && (adc1 < 1200))                   // podzakres od 666 mV do 900 mV >= 550< 1200
   {
   volt = map ( adc1, 550, 1195, 908, 676);
   sumaV = sumaV + volt;                                    // sumuje kolejne pomiary aż do lp
   delay(10);                  
  }  
//................................................/4/........................................................... 
  if ((adc1 >= 300) && (adc1 < 550))               // podzakres od 900 mV do 1000 mV >= 300adc1 < 550>= 260
   {
   volt = map ( adc1, 300, 550, 1008, 908);                   
   sumaV = sumaV + volt;                                  // sumuje kolejne pomiary aż do lp
   delay(10);                  
  }  
  } 
  digitalWrite(12,HIGH);                       // tranzystor Q1 włączony, wzmacniacz nie działa, zablokowany
  
//.....................................Wyświetlenie napięcia i prądu na LCD........................................ 

   volts = sumaV /lp ;                      // Napięcie średnie po lp pomiarach
   i = 0 ;                                  // zerowanie licznika pętli for
   sumaV = 0;                               // zerowanie zmiennej sumaV po lp pomiarach
  lcd.clear(); 
  lcd.setCursor(4, 0);                      //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print("U: ");
  if ( adc < 1)                       // próg pomiaru napięcia poniżej 0V
  {
   volts = 0;
  }
  lcd.print(volts,0);                 //Wyświetlenie mierzonego średniego napięcia
  lcd.print(" mV");  
 if ( adcp < 1)                       // zerowanie gdy prąd < 1 w adcp poniżej 0mA
  {
   sumaI = 0;
  }
   Is = sumaI /lp ;               // prąd sredni ze lp pomiarów
   i = 0 ;                        // zerowanie licznika pętli for
   sumaI = 0;                    // zerowanie zmiennej sumaI po lp pomiarach
if (bitRead(be,1) == 1)          // jeśli bit1 = 1,w zmiennej be, to panel z ograniczenim prądu
   {
  lcd.setCursor(0, 1);            //Ustawienie kursora wiersz 2-gi,kolumna 0 
  lcd.print("Ib");                // panel z ograniczeniem prądu "Ib" prąd bezpiecznika regulowany
  lcd.print(adcop); 
  lcd.setCursor(7 , 1); 
  lcd.print("mA"); 
  lcd.setCursor(10, 1);              //Ustawienie kursora wiersz 2-gi, 5-ta kolumna
  lcd.print("I ");
  lcd.print(Is,0);                //Wyświetlenie mierzonego średniego prądu
    }             
  else                          // panel bez ograniczenia prądu /tylko pomiay U: i I:/
  {
  lcd.setCursor(4, 1);              //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print("I: ");
  lcd.print(Is,0);                //Wyświetlenie mierzonego średniego prądu
  lcd.print(" mA"); 
  }
  }

//................................ Zakres od  1.000V do  2.000V  ........................................
                                    //....../1/.......podzakresy(sześć)                
 
  if ((adc > 154 ) && ( adc <= 200))                    // zakres  /1.0 V ... 1.250 V/ spr./> 197/
  {
   
  for (int i=0; i<lp; i++)
   {
    odczytA0();
   volt = map ( adc, 160, 200, 1003, 1237);
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                    
   } 
   obliczlcdV();                                        // odczyt napięcia średniego i na LCD
    }
 //........................................./2/.................................................................
   if ((adc > 200 ) && ( adc <= 216))               // zakres  /1.250 V ... 1.350 V/ spr./> 190/
  {
   
  for (int i=0; i<lp; i++)
   {
    odczytA0();
    volt = map (adc, 200, 216, 1238 , 1343 );
    sumaV = sumaV + volt;                               // sumuje kolejne pomiary aż do lp
   delay(10);                       
 } 
 obliczlcdV();                                          // odczyt napięcia średniego i na LCD
  }
//.........................................../3/............................................................... 
  if ((adc > 215 ) && ( adc <= 250))              // zakres  /1.350 V ... 1.500 V/ spr./> 190/
  {
   
  for (int i=0; i<lp; i++)
  {
    odczytA0();
   volt = map (adc, 220, 240, 1351, 1470);
   sumaV = sumaV + volt;                                    // sumuje kolejne pomiary aż do lp
   delay(10);                       
 } 
 obliczlcdV();                                              // odczyt napięcia średniego i na LCD
 }
//............................................./4/............................................................
 if ((adc > 250 ) && ( adc <= 265))                         // zakres  /1.500 V ... 1.600 V/ spr./> 190/
  {
  
  for (int i=0; i<lp; i++)
   {
    odczytA0();
   volt = map (adc, 244, 260, 1500, 1590);
    sumaV = sumaV + volt;                                   // sumuje kolejne pomiary aż do lp
   delay(10);                      
 } 
 obliczlcdV();                                              // odczyt napięcia średniego i na LCD
  }
//............................................./5/...........................................................
 if ((adc > 268 ) && ( adc <= 310))                         // zakres  /1.600 V ... 1.900 V/ spr./> 190/
  {
   for (int i=0; i<lp; i++)
   {
    odczytA0();
   volt = adc * 4.88 * 1.245;     
    sumaV = sumaV + volt;                                 // sumuje kolejne pomiary aż do lp
   delay(10);                      
 } 
 obliczlcdV();                                            // odczyt napięcia średniego i na LCD
 }
//............................................../6/...........................................................  
 if ((adc > 316 ) && ( adc <= 330))                     // zakres  /1.900 V ... 2.000 V/ spr./> 190/
  {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = adc * 4.88 * 1.24;    
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                      
 } 
 obliczlcdV();                                          // odczyt napięcia średniego i na LCD
  }
 
  
 //.....................................Zakres od 2.000V do 25.000V......................................
                                        //.../1/  podzakresy (dwadzieścia trzy)                   
 
  if ((adc > 330 ) && ( adc <= 510))                    // zakres /2.0 V ... 3.0 V/ spr.
  {
   for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 335, 505, 2026, 3030);
   sumaV = sumaV + volt;                              // sumuje kolejne pomiary aż do lp
   delay(10);                    
   } 
   obliczlcdV();                                    // odczyt napięcia średniego i na LCD
    }
//........................................../2/..................................................................    
 if ((adc > 512) && ( adc <= 680))                    // zakres  /3.0 V ... 4.0 V/ spr.
   {
   for (int i=0; i<lp; i++)
   {
   odczytA0();
    volt = map (adc, 515, 680, 3092, 4062);
    sumaV = sumaV + volt;                             // sumuje kolejne pomiary aż do lp
    delay(10);                    
  } 
   obliczlcdV();                                      // odczyt napięcia średniego i na LCD
   }
//............................................/3/...............................................................   
  if ((adc > 680) && ( adc <= 840))                     // zakres  /4.0 V ... 5.0 V/ spr.
   {
    for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = adc * 4.88 * 1.222 ; 
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                    
    } 
  obliczlcdV();                                          // odczyt napięcia średniego i na LCD
    }
//............................................./4/.............................................................    
  if ((adc > 840) && ( adc <= 1020))                    // zakres  /5.0 V ... 6.0 V/ spr.
    {
     for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 840, 1020, 5010, 6069);
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                  
    } 
   obliczlcdV();                                        // odczyt napięcia średniego i na LCD
    }
//............................................./5/............................................................    
  if ((adc > 1020) && ( adc <= 1190 ))                  // zakres  /6.0 V ... 7.0 V/ spr.
  {
    for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 1020, 1190, 6070, 7070);
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                    
    } 
  obliczlcdV();                                         // odczyt napięcia średniego i na LCD
    }
//............................................../6/...........................................................   
   if ((adc > 1190) && ( adc <= 1360 ))                 // zakres  /7.0 V ... 8.0 V/ spr.
  {
   for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 1190, 1360, 7070, 8072); 
   sumaV = sumaV + volt;                                  // sumuje kolejne pomiary aż do lp
   delay(10);                                  // czas między każdym jednym pomiarem napięcia z lp pomiarów
  } 
  obliczlcdV();                                   // odczyt napięcia średniego i na LCD
   }
//............................................../7/..........................................................    
  if ((adc > 1360) && ( adc <= 1525 ))                    // zakres  /8.0 V ... 9.0 V/ spr.
  {
    for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 1360, 1525, 8075, 9045); 
   sumaV = sumaV + volt;                                     // sumuje kolejne pomiary aż do lp
   delay(10);                   
   } 
  obliczlcdV();                                             // odczyt napięcia średniego i na LCD
    }
//................................................/8/........................................................    
   if ((adc > 1525) && ( adc <= 1700 ))                   // zakres  /9.0 V ... 10.0 V/ spr.
  {
      for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 1525, 1700, 9042, 10068); 
   sumaV = sumaV + volt;                                  // sumuje kolejne pomiary aż do lp
   delay(10);                                   //czas między każdym jednym pomiarem napięcia z lp pomiarów
   } 
  obliczlcdV();                                     // odczyt napięcia średniego i na LCD
    }
//................................................/9/........................................................    
   if ((adc > 1700) && ( adc <= 1865 ))                   // zakres  / 10.0 V ... 11.0 V/ spr.
  {
    for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 1700, 1865, 10066, 11039);  
   sumaV = sumaV + volt;                                          // sumuje kolejne pomiary aż do lp
   delay(10);                                   //czas między każdym jednym pomiarem napięcia z lp pomiarów
   } 
  obliczlcdV();                                     // odczyt napięcia średniego i na LCD
    }
//............................................../10/.........................................................     
   if ((adc > 1865) && ( adc <= 2040 ))                   // zakres  /11.0 V ... 12.0 V/ spr.
  {
     for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = adc * 4.88 * 1.214 ; 
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                    
  } 
   obliczlcdV();                                        // odczyt napięcia średniego i na LCD
   }
//............................................/11/.........................................................   
  if ((adc > 2040) && ( adc <= 2200 ))                          // zakres  /12.0 V ... 13.0 V/ spr.
  {
     for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = adc * 4.88 * 1.213 ;                          
   sumaV = sumaV + volt;                                      // sumuje kolejne pomiary aż do lp
   delay(10);                    
   } 
  obliczlcdV();                                             // odczyt napięcia średniego i na LCD
    }
//............................................./12/........................................................    
  if ((adc > 2200) && ( adc <= 2370 ))                          // zakres  /13.0 V ... 14.0 V/ spr.
  {
     for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 2200, 2370, 13016, 14018);
   sumaV = sumaV + volt;                                        // sumuje kolejne pomiary aż do lp
   delay(10);                    
    } 
  obliczlcdV();                                               // odczyt napięcia średniego i na LCD
    }
//................................................/13/......................................................     
  if ((adc > 2370) && ( adc <= 2545  ))                         // zakres  /14.0 V ... 15.0 V/ spr.
  {
    for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 2370, 2545, 14015, 15055);
   sumaV = sumaV + volt;                                        // sumuje kolejne pomiary aż do lp
   delay(10);                   
    } 
  obliczlcdV();                                             // odczyt napięcia średniego i na LCD
    }
//................................................/14/.........................................................    
  if ((adc > 2545) && (adc <= 2710))                        // zakres  /15.0 V ... 16.0 V/ spr.
  {
    for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 2545, 2710, 15051, 16039); 
   sumaV = sumaV + volt;                                      // sumuje kolejne pomiary aż do lp
   delay(10);                   
    } 
   obliczlcdV();                                            // odczyt napięcia średniego i na LCD
    }
//.............................................../15/..........................................................   
 if ((adc > 2710) && (adc <= 2870))                       // zakres  /16.0 V ... 17.0 V/ spr.
  {
     for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 2710, 2870, 16033, 17017);
   sumaV = sumaV + volt;                                  // sumuje kolejne pomiary aż do lp
   delay(10);                   
    } 
   obliczlcdV();                                        // odczyt napięcia średniego i na LCD 
    }
//.............................................../16/........................................................    
  if ((adc > 2870) && (adc <= 3030))                            // zakres / 17.0 V ... 18.0 V/ spr.
   {
     for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 2870, 3030, 17020, 18020);                //(adc, 2870, 3030, 17020, 18038)
   sumaV = sumaV + volt;                                    // sumuje kolejne pomiary aż do lp
   delay(10);                   
  } 
  obliczlcdV();                                             // odczyt napięcia średniego i na LCD  
  }
//................................................/17/....................................................    
  if ((adc > 3030) && (adc <= 3176))                           // zakres / 18.0 V ... 19.0 V/ spr.
 {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 3030, 3178, 18038, 19000);                //(adc, 3030, 3176, 18038, 19025)
   sumaV = sumaV + volt;                                      // sumuje kolejne pomiary aż do lp
   delay(10);                   
  } 
   obliczlcdV();                                            // odczyt napięcia średniego i na LCD 
   }
//.............................................../18/.....................................................    
 if ((adc > 3176) && (adc <= 3316))                         // zakres / 19.0 V ... 20.0 V/ spr.
 {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map (adc, 3176, 3320, 19025, 20000);                //(adc, 3176, 3316, 19025, 20050)
   sumaV = sumaV + volt;                                      // sumuje kolejne pomiary aż do lp
   delay(10);                    
  } 
   obliczlcdV();                                              //  odczyt napięcia średniego i na LCD
   }
//.............................................../19/..........................................................     
   if ((adc > 3316) && (adc <= 3430))                       // zakres / 20.0 V ... 21.0 V/ spr.
 {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map ( adc, 3316, 3436, 20055, 20900);           //( adc, 3316, 3430, 20055, 20990)
   sumaV = sumaV + volt;                                  //sumuje kolejne pomiary aż do lp
   delay(10);                    
  } 
   obliczlcdV();                                        // odczyt napięcia średniego i na LCD 
   }
//.............................................../20/..........................................................    
   if ((adc > 3430) && (adc <= 3540))                    // zakres / 21.0 V ... 22.0 V/ spr.
 {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map ( adc, 3430, 3560, 20993, 22000);               // ( adc, 3430, 3540, 20993, 22050
   sumaV = sumaV + volt;                                  // sumuje kolejne pomiary aż do lp
   delay(10);                   
  } 
  obliczlcdV();                                         // odczyt napięcia średniego i na LCD 
   }
//............................................../21/..........................................................     
   if ((adc > 3540) && (adc <= 3630))                     // zakres / 22.0 V ... 23.0 V/ spr.
 {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map ( adc, 3540, 3660, 22056, 23000);                 //( adc, 3540, 3630, 22056, 23095)
   sumaV = sumaV + volt;                                    // sumuje kolejne pomiary aż do lp
   delay(10);                   
  } 
  obliczlcdV();                                       // odczyt napięcia średniego i na LCD 
    }
//............................................../22/...........................................................   
   if ((adc > 3630) && (adc <= 3700))                         // zakres / 23.0 V ... 24.0 V/ spr.
   {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map ( adc, 3630, 3735, 23102, 24000);                 //( adc, 3630, 3705, 23102, 24160)
    sumaV = sumaV + volt;                                     // sumuje kolejne pomiary aż do lp
   delay(10);                    
  } 
 obliczlcdV();                                              // odczyt napięcia średniego i na LCD    
  }
//............................................./23/...........................................................     
  if ((adc > 3700) && (adc <= 3800))                       // zakres / 24.0 V ... 25.0 V/ spr./3770
   {
  for (int i=0; i<lp; i++)
   {
   odczytA0();
   volt = map ( adc, 3700, 3800, 23830, 25360);         //( adc, 3700, 3770, 24100, 25325)24100/25000 
   sumaV = sumaV + volt;                                // sumuje kolejne pomiary aż do lp
   delay(10);                   
  } 
  obliczlcdV();                                       // odczyt napięcia średniego i na LCD  
   }
//............................................................................................................   
 if (adc > 3800)                          // napięcie U > 25.000V /POZA ZAKRESEM/                            
 {
  lcd.clear(); 
  lcd.setCursor(2, 0);              //Ustawienie kursora wiersz pierszy, 2-ga kolumna
  lcd.print("POZA ZAKRESEM");
 }
 //,,,,,,,,,,,,,,,,,,,,,,,,,,1
  if ( adcp < 1)                   // próg pomiaru prądu /wartość <...  jest jako 0mA/
  {
   sumaI = 0;
  }
   Is = sumaI /lp ;               // prąd sredni ze lp pomiarów
   i = 0 ;                        // zerowanie licznika pętli for
   sumaI = 0;                    // zerowanie zmiennej sumaI po lp pomiarach
 if (bitRead(be,1) == 1)        // jeśli bit1 = 1, to panel o ograniczenim prądu
   {
  lcd.setCursor(0, 1);            //Ustawienie kursora wiersz 2-gi,kolumna 0 
  lcd.print("Ib");                //panel z bezpiecznikiem prądu
  lcd.print(adcop);               //nastawa z P1 bezpiecznika prądu/prąd bezpiecznika elektronicznego
  lcd.setCursor(7 , 1); 
  lcd.print("mA"); 
  lcd.setCursor(10, 1);              //Ustawienie kursora wiersz 2-gi, 5-ta kolumna
  lcd.print("I ");
  lcd.print(Is,0);                //Wyświetlenie mierzonego średniego prądu
    }             
  else                          // panel bez ograniczenia prądu /tylko pomiay U: i I:/
  {
  lcd.setCursor(4, 1);              //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print("I: ");
  lcd.print(Is,0);                //Wyświetlenie mierzonego średniego prądu
  lcd.print(" mA"); 
  }
  //,,,,,,,,,,,,,,,,,,,
//------------------------------------ POMIAR PRADU ------------------------------------------
                                   //..... Zakres od 0 mA do 300 mA (trzy podzakresy)

 digitalWrite(13, LOW);                 // tranzystor Q2 przewodzi małe wzmocnienie/pom.dużych prądów/
 adcp = analogRead(A1);                 // A1, wejście analogowe do pomiaru prądu/napięcie na R16/
 if ( adcp <= 185  )                     // pomiar prądu od 0 mA ... 300 mA/jeśli warunek spełniony/
{
  digitalWrite(13, HIGH);               // tranzystor Q2 zatkany duże wzmocnienie/pom.małych prądów/
  for (int i=0; i<lp; i++)
   {
   adcp1 = analogRead(A1);             //..../1/....podzakres....
   if ( adcp1 <= 220  )                      // podzakres od 0 mA ... 100 mA( adcp1 <= 220 )
   {
   I = map (adcp1, 15, 255, 11, 110);        // jeden ze lp  pomiarów prądu( adcp1, 15, 243, 11, 116)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/   
   }
// ......................................./2/.........................................................
    if ((adcp1 > 220 )&&( adcp1 <= 430))   //podzakres od 100 mA ... 200 mA(( adcp1 > 220 )&&( adcp1 <= 430))
    {
   I = map (adcp1, 220, 465, 100, 190);      // jeden ze lp pomiarów prądu(adcp1, 220, 430, 103, 207)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/  
    }
// ......................................./3/.............................................................
     if ((adcp1 > 430 )&&( adcp1 <= 685)) //podzakres od 200 mA ... 300 mA /675((adcp1 > 430 )&&( adcp1 <= 685))
    {
   I = map (adcp1, 426, 645, 188, 280);     //  jeden ze lp pomiarów prądu(adcp1, 426, 635, 202, 295)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/    
   }
   }
  digitalWrite(13, LOW);              // tranzystor Q2 przewodzi małe wzmocnienie/pom.dużych prądów/
  }
// ......................................... Zakres od 300 mA do 2000 mA...................................................................
                                      //.../1/... podzakres (cztery podzakresy)
                                      
if ((adcp > 185) && (adcp <= 345))    // podzakres od 300 mA ... 900 mA
   {
  digitalWrite(13, LOW);              // tranzystor Q2 otwarty małe wzmocnienie /pom.dużych prądów/
   for (int i=0; i<lp; i++)
   {
   adcp = analogRead(A1);
   I = map (adcp, 195, 345, 327, 820);       //jeden ze lp pomiarów prądu /795/(adcp, 185, 316, 319, 804)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/               
  } 
  }
// ......................................../2/.................................................................
digitalWrite(13, LOW);
if ((adcp > 345) && (adcp <= 490))    // podzakres od 900 mA ... 1300 mA((adcp > 345)&&(adcp <= 510))
   {
  digitalWrite(13, LOW);              // tranzystor Q2 otwarty małe wzmocnienie /pom.dużych prądów/
   for (int i=0; i<lp; i++)
   {
   adcp = analogRead(A1)* 0.953;
   I = map (adcp, 348, 490, 900, 1400);      //  jeden ze lp pomiarów prądu /795/(adcp, 345, 515, 910, 1540)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/                 
  } 
  }
// ......................................../3/...................................................................
digitalWrite(13, LOW);
if ((adcp > 490) && (adcp <= 600))    // podzakres od 1300 mA ... 1700 mA((adcp > 510)&&(adcp <= 660))
   {
  digitalWrite(13, LOW);              // tranzystor Q2 otwarty małe wzmocnienie /pom.dużych prądów/
   for (int i=0; i<lp; i++)
   {
   adcp = analogRead(A1);
   I = map  (adcp, 485, 600, 1325, 1700);     // jeden ze lp pomiarów prądu (adcp, 510, 650, 1515, 2022)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/                 
  } 
  }
// ........................................./4/.................................................................
digitalWrite(13, LOW);
if ((adcp > 600) && (adcp <= 710))    // podzakres od 1700 mA ... 2000 mA((adcp > 510)&&(adcp <= 660))
   {
  digitalWrite(13, LOW);              // tranzystor Q2 otwarty małe wzmocnienie /pom.dużych prądów/
   for (int i=0; i<lp; i++)
   {
   adcp = analogRead(A1);
   I = map  (adcp, 600, 705, 1700, 2040);    // jeden ze lp pomiarów prądu (adcp, 510, 650, 1515, 2022)
   sumaI = sumaI + I;                        // sumuje kolejne lp pomiarów prądu
   delay(10);                               // zwłoka czasowa między każdym ze lp pomiarów /10ms/                 
  } 
  }
// ..........................................................................................................
digitalWrite(13, LOW);
if (adcp > 710)                       //poza zakresem pomiarowym I > 2000 mA (adcp > 660)
{
  bitClear(be,0);                   // bit0 = 0,w zmiennej be, zadziałał bezpiecznik elektroniczny.
  digitalWrite(9, HIGH);            // włączenie diody LC +LEDczerwona zadziałanie Bezpiecznika
  digitalWrite(10, LOW);            //włączenie diody LC -LEDczerwona zadziałanie Bezpiecznika
  
  lcd.clear(); 
  lcd.setCursor(4, 0);              //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print(volts/1000,3);          //Wyświetlenie mierzonego średniego napięcia
  lcd.print(" V");  
  lcd.setCursor(2, 1);              //Ustawienie kursora wiersz pierszy, 2-ga kolumna
  lcd.print("POZA ZAKRESEM");
  delay(200);
}
//....................................... BEZPIECZNIK ELEKTRONICZNY ..............................
/* Suwak potencjometru P1, nastawy ograniczenia prądu(Wyłączenia przez Bezpiecznik Elektroniczny)podłączony 
 do wejścia analogowego A2.
Jeśli bezpiecznik elektroniczny nie zadziałał, to bit0 = 1,w zmiennej be, pin cyfrow 9 ma stan niski, pin 10 stan wysoki.
Jeśli prąd mierzony jest większy niż nastawa z potencjometru, to zadziała bezpiecznik elektronioniczny.
Bit znacznik bit0 = 0.
Zaświeci się dioda czerwona LC, czyli pin 9 zmieni stan na wysoki a pin 10 na niski. Tą zmianę można wykorzystać
do wyłączenia napięcia, jeśli panel będzie użyty np. w zasilaczu.
Po usunięciu przeciążenia można wcisnąć przycisk KAS, dioda czerwona LC zgaśnie, a pin 9 = LOW i 10 = HIGH.
Tak działą wersja penala pomiarowego z bezpiecznikim, czyli na LCD w górnej linii wyświetla mierzone napięcie,
w dolnej od lewej wartość ograniczenia prądu nastawionego, a następnie prąd pomierzony.
Jeśli nie mamy przeciążenia, możemy wcisnąć przycisk KAS, a to oznacza że wybraliśmy panel bez bezpicznika
elektornicznego. Zaświeci się żółta dioda LED LZ, jako ostrzeżeni, że nie mamy żadnego zabezpieczenia nadprądowego.
Na wyświetlaczu may tylko w górnej linii wartość mierzonego napięcia, a w dolenj mierzony prąd.
Znacznik bit1 = 1,w zmiennej be, panel z bezpiecznikiem prądu. Znacznik bit1 = 0, panel bez bezpiecznika prądu.
Aby przycisk KAS zadziałał natychmiast, wykorzystano przerwanie zewnętrzne pin 3 (INT1), do którego
podłączono przycisk.
*/

adcop = analogRead(A2);               // odczyt z suwaka potencjometru P1, Bez. Elektroniczny Ib
adcop =  adcop * 1.959;               //Bez. Elektroniczny prądu, nastawa potencjometr, P1 do 2000 mA

//........................ Ograniczenie Prądu (Sygnalizacja Zadziałania Bezpiecznika Elektronicznego) .....................................


              
if ( bitRead(be,1) == 1 )           // jeśli bit1 = 1,w zmiennej be,to mamy panel z ograniczniem prądu
{                               
if ( Is > adcop )                   // jeśli prąd mierzony jest większy od ustawionego prądu ograniczenia
{                                              
  bitClear(be,0);                   // bit0 = 0,w zmiennej be,zadziałał bezpiecznik elektroniczny. 
  digitalWrite(9, HIGH);            // włączenie diody LC +LEDczerw. zadziałanie Bezpiecznika, sygnalizacja
  digitalWrite(10, LOW);            // włączenie diody LC -LEDczerw. zadziałanie Bezpiecznika, sygnalizacja
}                             
}
  

if ((bitRead(be,0) == HIGH))  // przerwanie, wybór panela przyciskiem KAS, gdy nie zadziałał bez.elektroniczny
{                                                       
attachInterrupt(digitalPinToInterrupt(kas), panel, LOW);               
}
if ((bitRead(be,0) == LOW))             // przerwanie,kasowanie gdy bez.elekr. zadziałał
{                                                       
attachInterrupt(digitalPinToInterrupt(kas), kasowanie, LOW);   
}


}                             // KONIEC loop


//.................................. PODPROGRAMY:......PROCEDURY PRZERWAŃ: .............................


void kasowanie()                              // Kasowanie gdy Bezpiecznik Elektroniczny zadziałał 
{
  if((digitalRead(kas) == LOW)&& (bitRead(be,0) == 0))  
{                           
   digitalWrite(9, LOW);                      // wyłączenie diody LC +LEDczerw.
   digitalWrite(10, HIGH);                    // wyłączenie diody LC -LEDczerw.
   bitSet(be,0);                              // bit0 = 1,w zmiennej be, w stanie wysokim, Bez. Elektr. Nie zadziałał
   
 while ((digitalRead(kas)== LOW))             // dopóki wciśnięty przycisk KAS,program czeka na puszczenie 
  {                               
  }                              
}
}

//............................. Wybór: Panel Z Ograniczeniem Prądu (z Bez. Elekrtonicznym) .........................

void panel()                          // przełączanie między dwoma obcjami Panela Pomiarowego
{
  if ((bitRead(be,0) == HIGH)&&(bitRead(be,1)==0))
  {
                                            
  bitSet(be,1);                               // bit1 = 1,w zmiennej be, panel z Bez. Elekrtonicznym
  digitalWrite(11, LOW);                    // dioda LZ, LED żółta nie świeci
  while ((digitalRead(kas)== LOW))             // dopóki wciśnięty przycisk KAS działa pętla
  {
  }
  }                               


 //................. Wybór: Panel Bez Ograniczenia Prądu (bez Bezpiecznika Elekr.)/tylko pomiay U: i I:/................
 
if ((digitalRead(kas) == LOW)&& (bitRead(be,0) == HIGH))   //jeśli bit bit0 = 1,w zmiennej be
                                                          //to nie zadziałał bez. elektr.
                                                          //i wtedy można przyciskiem KAS przełączyć 
                                                        //na jedną z obcji Panela Pomiarowego
{
   bitClear(be,1);                        //bit1 = 0,w zmiennej be, panel Bez bezpiecznika /tylko pomiay U: i I:/
   digitalWrite(11, HIGH);                // dioda LZ, LED żółta świeci(bez Bezpiecznika Elekronicznego)
   while ((digitalRead(kas)== LOW))        // dopóki wciśnięty przycisk KAS działa pętla
  {
  }
  }
}

void odczytA0()                 // odczyt napięcia z pinu A0,które jest przeznaczone do pomiaru napięcia
{
   adc = analogRead(A0);       // analogowy doczyt napięcia z pinu A0 i zapis do zmiennej adc
   adc = adc * 4.044  ;         //* współczynnik,stosunek podziału dzielnika
 }                              

 void obliczlcdV()            // oblicza średnie napięcie i wyświetla na LCD 
  {
   volts = sumaV /lp ;        // Napięcie średnie po lp pomiarach
   i = 0 ;                   //zerowanie licznika pętli for
   sumaV = 0;                 // zerowanie zmiennej sumaV po lp pomiarach
  lcd.clear(); 
  lcd.setCursor(4, 0);              //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print("U: ");
  lcd.print(volts/1000,3);          //Wyświetlenie mierzonego średniego napięcia
  lcd.print(" V"); 
  if ( adcp < 1)                   // próg pomiaru napięcia /wartość <...  jest jako 0V/
  {
   sumaI = 0;
  }
   Is = sumaI /lp ;               // prąd sredni ze lp pomiarów
   i = 0 ;                        // zerowanie licznika pętli for
   sumaI = 0;                    // zerowanie zmiennej sumaI po lp pomiarach
 if (bitRead(be,1) == 1)        // jeśli bit1 = 1, to panel o ograniczenim prądu
   {
  lcd.setCursor(0, 1);            //Ustawienie kursora wiersz 2-gi,kolumna 0 
  lcd.print("Ib");                //panel z bezpiecznikiem prądu
  lcd.print(adcop);               //nastawa z P1 bezpiecznika prądu/prąd bezpiecznika elektronicznego
  lcd.setCursor(7 , 1); 
  lcd.print("mA"); 
  lcd.setCursor(10, 1);              //Ustawienie kursora wiersz 2-gi, 5-ta kolumna
  lcd.print("I ");
  lcd.print(Is,0);                //Wyświetlenie mierzonego średniego prądu
    }             
  else                          // panel bez ograniczenia prądu /tylko pomiay U: i I:/
  {
  lcd.setCursor(4, 1);              //Ustawienie kursora wiersz pierszy, piąta kolumna
  lcd.print("I: ");
  lcd.print(Is,0);                //Wyświetlenie mierzonego średniego prądu
  lcd.print(" mA"); 
  }
  }

  //... 12842  bajtów. Program opracowany i przetestowany z użyciem Arduino UNO    .......
 
 
 


